#include "cdialog_setup.h"
#include "ui_cdialog_setup.h"


#include <QMessageBox>



cDialog_Setup::cDialog_Setup(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::cDialog_Setup)
{
    ui->setupUi(this);

    int msecs = 200;

    timer = new QTimer(this);
    timer->setInterval(msecs);
    timer->start();

    connect(timer, SIGNAL(timeout()), this, SLOT(load_text_boxs()));



}



cDialog_Setup::~cDialog_Setup()
{
    delete ui;
}

void cDialog_Setup::load_text_boxs()
{
    timer->stop();

    //can't do this here; probably need to setup a timer and callback
    ui->lineEdit->setText(sFarm );
    ui->lineEdit_2->setText(sClient);
    ui->lineEdit_3->setText(sField);
    ui->lineEdit_4->setText(sNum_rows);
    ui->lineEdit_5->setText(sRow_width);



    if(sWindCondition == "CALM")
    {
        ui->radioButton->setChecked(true);
    }
    else if(sWindCondition == "NORMAL")
    {
        ui->radioButton_2->setChecked(true);
    }
    else
    {
        ui->radioButton_3->setChecked(true);
    }

}

void cDialog_Setup::display_blank_input_error()
{
    QMessageBox::about(this, tr("Input Error"),
                       tr("Data must be loaded for Farm, Field and Client.  Please try again."));

}

//cancel; return back to main screen
void cDialog_Setup::on_pushButton_2_clicked()
{
    int cnt = ui->lineEdit->text().length();
    if(cnt == 0)
    {
        //send up QMessage & stop
        display_blank_input_error();
        return;
    }

    cnt = ui->lineEdit_3->text().length();
    if(cnt == 0)
    {
        //send up QMessage & stop
        display_blank_input_error();
        return;
    }

    cnt = ui->lineEdit_2->text().length();
    if(cnt == 0)
    {
        //send up QMessage & stop
        display_blank_input_error();
        return;
    }



    this->close();
}

//accept input parameters; then go back to main screen
void cDialog_Setup::on_pushButton_clicked()
{
    //ck if blank, if so send up msgbox and refuse to exit

    int cnt = ui->lineEdit->text().length();
    if(cnt == 0)
    {
        //send up QMessage & stop
        display_blank_input_error();
        return;
    }

    cnt = ui->lineEdit_3->text().length();
    if(cnt == 0)
    {
        //send up QMessage & stop
        display_blank_input_error();
        return;
    }

    cnt = ui->lineEdit_2->text().length();
    if(cnt == 0)
    {
        //send up QMessage & stop
        display_blank_input_error();
        return;
    }



    //save data to our database
    save_client_info_to_sql();

    this->close();
}

//prompt for password, then if accept, goto engr setup screen
void cDialog_Setup::on_pushButton_3_clicked()
{

}

void cDialog_Setup::save_client_info_to_sql()
{
    QString tableName = "FarmINFO";

    QStringList colNames;
    QStringList dataVals;

    colNames << "FARM" << "CLIENT" << "FIELD" << "NUM_ROWS" << "ROW_WIDTH";

    sFarm = ui->lineEdit->text();
    sClient = ui->lineEdit_2->text();
    sField = ui->lineEdit_3->text();
    sNum_rows = ui->lineEdit_4->text();
    sRow_width = ui->lineEdit_5->text();


    if(ui->radioButton->isChecked() )
    {
        sWindCondition = "CALM";
    }
    else if(ui->radioButton_2->isChecked() )
    {
        sWindCondition = "NORMAL";
    }
    else
    {
        sWindCondition = "WINDY";
    }

    dataVals << sFarm << sClient << sField << sNum_rows << sRow_width;


    bool ok = csql->testDB_tableExists(tableName);


    if(ok)
    {
        csql->clearDB_table(tableName);
        int rowID = csql->insertROW_into_table(tableName, colNames, dataVals);

    }


}


