#include "csql_utils.h"

#include <QDebug>

#include <QCoreApplication>

#include <QStandardPaths>

#include <QMessageBox>

#include <QDir>
#include <QFile>
#include <QTextStream>
#include <QStringList>
#include <QString>

#include <QtSql/QSqlDatabase>
#include <QtSql>
#include <QtSql/QSqlField>

#include <iostream>

//IMPORTANT!!! MUST ADD
//QT += sql TO PRO FILE!!!


//good ref for example sqlite commands
//http://www.java2s.com/Code/Cpp/Qt/ConnecttoSqliteanddoinsertdeleteupdateandselect.htm


/* to use multiple dataBases (either attach to already open database or use another db pointer
 * sqlite3 database1.db
    > ATTACH DATABASE 'database2.db' AS database2;
    > INSERT INTO mytable SELECT * FROM database2.mytable;
*/


cSQL_Utils::cSQL_Utils()
{

    //QString docsPath = QStandardPaths::StandardLocation(QStandardPaths::DesktopLocation);
    //QStringList paths = QStandardPaths::standardLocations(QStandardPaths::DesktopLocation);
    QStringList paths = QStandardPaths::standardLocations(QStandardPaths::DocumentsLocation);

    QString docsPath = paths[0];


    db = QSqlDatabase::addDatabase( "QSQLITE" );

    //for now do this; as we do have permission setup correctly for this
    //dbPath = QDir::currentPath() + "./MASTER_DATALOGGER_DBASE.sqlite";

    //this works
    dbPath = "./MASTER_DATALOGGER_DBASE.sqlite";

    //doesn't work
    dbPath = "~/cgi/MASTER_DATALOGGER_DBASE.sqlite";


    //this works on desktop at home
    dbPath = "/home/ubuntu14/cgi/MASTER_DATALOGGER_DBASE.sqlite";

    dbPath = docsPath + "/MASTER_DATALOGGER_DBASE.sqlite" ;




    //this works ON HOME DESKTOP MACHINE (CGI FOLDER); doesn't work on Work Desktop (permissions different?)
//    dbPath = "/usr/lib/cgi-bin/MASTER_DATALOGGER_DBASE.sqlite";


    //this doesn't work ON WORK DESKTOP MACHINE (CGI FOLDER) permissions different?)
//    dbPath = "/var/www/test-cgi/MASTER_DATALOGGER_DBASE.sqlite";


    //following doesn't work; perhaps we need different permissions?
    //dbPath = QDir::currentPath() + "~/cgi/testdatabase.db";
    //dbPath = QDir::currentPath() + "/home/ubuntu14/cgi/testdatabase.db";

    dbName = "MasterDB";

    //db = QSqlDatabase::addDatabase("QSQLITE", dbName);

    //db.setDatabaseName(dbPath);


}
cSQL_Utils::~cSQL_Utils()
{
    db.close();
}

QSqlError cSQL_Utils::lastError()
{
    return db.lastError();
}



void cSQL_Utils::setDB_path(QString path)
{
    dbPath = path;
}

//use default path
bool cSQL_Utils::create_sqlite_dataBase()
{

    db.close();

    //db.setDatabaseName( "./testdatabase.db" );
    db.setDatabaseName( dbPath );

    if( !db.open() )
    {
      qDebug() << db.lastError();
      qFatal( "Failed to connect." );

      return false;
    }


    return true;

    db.close();


    db.addDatabase("QSQLITE", dbName);


    db.setDatabaseName(dbPath);


    //attach_sqlite_dataBase(dbName, dbPath);

    if(!db.open())
        return false;

    dbIsOpen = true;

    dbPathList.append(dbPath);
    dbNamesList.append(dbName);

    db.commit();

}



//use default path & attach with alias name
bool cSQL_Utils::create_sqlite_dataBase(QString db_Path)
{
    //db.close();

    //db = QSqlDatabase::addDatabase("QSQLITE");

    //db.setDatabaseName(dbPath);
    //db.setDatabaseName(":memory:");
    //db.setDatabaseName();

    //attach_sqlite_dataBase(dbName, dbPath);

    //if(!db.open())
    //    return false;

    //dbIsOpen = true;

    dbPath = db_Path;

    create_sqlite_dataBase();

    //path is dbName
    //dbName = db_Name;

    //attach_sqlite_dataBase(dbName, dbPath);

    //dbPathList.append(dbPath);
    //dbNamesList.append(dbName);

    //db.commit();
}

//not tested
bool cSQL_Utils::create_sqlite_dataBase(QString db_Name, QString db_path)
{
    return false;

    //QSqlDatabase db = QSqlDatabase::addDatabase("QSQLITE");
    //db.setDatabaseName("C:\\Users\\Tanner\\Desktop\\db.sqlite");

    db.close();

    //db = QSqlDatabase::addDatabase("QSQLITE");

    dbPath = db_path;
    dbName = db_Name;


    db.setDatabaseName(dbPath);
    //attach_sqlite_dataBase(dbName, dbPath);

    db.open();
    dbIsOpen = true;


    attach_sqlite_dataBase(dbName, dbPath);

    dbPathList.append(dbPath);
    dbNamesList.append(dbName);

    db.commit();


}

//attach another database so we can access more than one at a time
//> ATTACH DATABASE 'database2.db' AS database2;
//> INSERT INTO mytable SELECT * FROM database2.mytable;
//SQLITE_MAX_ATTACHED which is set to 10 by default. The maximum number of attached databases cannot be increased above 125.
bool cSQL_Utils::attach_sqlite_dataBase(QString db_Name, QString db_path)
{
    bool ret = false;
    QSqlQuery qry;


    QString sql;

    sql = "ATTACH DATABASE " + db_path + " AS " + db_Name;

    qry.prepare( sql );
    if( qry.exec() )
        ret = true;


    dbPathList.append(db_path);
    dbNamesList.append(db_Name);


    db.commit();

    return ret;
}

bool cSQL_Utils::open_sqlite_dataBase()
{
    bool ok = create_sqlite_dataBase();

    return ok;
}

bool cSQL_Utils::open_sqlite_dataBase(QString db_path)
{
    //according to docs; no difference to open or create; sqlite will simply use an existing database or create one if it doesn't exist
    bool ok = create_sqlite_dataBase(db_path);

    return ok;
}

bool cSQL_Utils::closeDB()
{
    try
    {
        db.commit();
    }
    catch(...){}

    db.close();

    dbIsOpen = false;


    dbPathList.clear();
    dbNamesList.clear();


    return true;
}

bool cSQL_Utils::deleteDB()
{
    db.close();

    dbPathList.clear();
    dbNamesList.clear();

    QFile::remove(dbPath);

    return true;
}


//Clear all rows in table; but leave table intact
bool cSQL_Utils::clearDB_table(QString tableName)
{
    bool ok = false;
    QSqlQuery qry;

    if(db.open())
    {
        bool found = cSQL_Utils::testDB_tableExists(tableName);
        if(found)
        {
            QString sql = "DELETE FROM " + tableName;

            qry.prepare( sql );

            if(qry.exec() )
            {
                ok=true;
                db.commit();
            }
        }

    }

    return ok;
}


//deletes table
bool cSQL_Utils::dropDB_table(QString tableName)
{
    bool ok = false;
    QSqlQuery qry;

    if(db.open())
    {
        QString sql = "DROP TABLE " + tableName;

        qry.prepare( sql );

        if(qry.exec() )
            ok=true;

        db.commit();

    }

    return ok;
}


bool cSQL_Utils::testDB_tableExists(QString tableName)
{
    bool inDb = false;


    if ( db.tables().contains( tableName ) )
    {
        inDb = true;

        //db.commit();

    }


    return inDb;
}

QStringList cSQL_Utils::getDB_tableColumnNames(QString tableName)
{
    QStringList fields;
    QSqlQuery qry;

    //QString sql = "select * from mytable LIMIT 0, 0"; //don't actually select anything but get a reference to the record set

    QString sql = "select * from " + tableName + " LIMIT 0, 0"; //don't actually select anything but get a reference to the record set


    qry.prepare( sql );
    if(!qry.exec() )
        return fields;


    QSqlRecord rec = qry.record();


    for (int i=0; i<rec.count(); i++)
    {
        fields.append(rec.fieldName(i));
    }

    //now, fields contains a list of field names
    return fields;
}

QStringList cSQL_Utils::getDB_tableTypeNames(QString tableName)
{
    QStringList fieldTypes;
    QSqlQuery qry;

    //QString sql = "select * from mytable LIMIT 0, 0"; //don't actually select anything but get a reference to the record set

    QString sql = "select * from " + tableName + " LIMIT 0, 0"; //don't actually select anything but get a reference to the record set


    qry.prepare( sql );
    if(!qry.exec() )
        return fieldTypes;


    QSqlRecord rec = qry.record();

    int cnt = rec.count();

    for (int i=0; i<cnt; i++)
    {
        QSqlField field = rec.field(i);
        //QString fieldName = rec.fieldName(i);
        QString fieldType = QVariant::typeToName(field.type());
        fieldTypes.append(fieldType);
    }

    //now, fields contains a list of field names
    return fieldTypes;
}



//how to deal with multiple databases?
QStringList cSQL_Utils::getDB_tableNames()
{
    QSqlQuery qry;
    QStringList tables;

    qry.prepare("SELECT * FROM sqlite_master");

    while (qry.next())
    {
        qDebug() << qry.value("sql").toString();
        if (qry.value("type").toString() == "table")
        {
            QString sVal = qry.value("name").toString();
            tables.append(sVal);
        }
    }

    return tables;
}


QString cSQL_Utils::getValue_colQuery_table(QString col_IDName, QString row_IDValue, QString queryColName, QString tableName)
{
    QStringList rowValues;
    QString sVal= "-1";
    QSqlQuery qry;

    QString sql = "SELECT " + queryColName + " FROM " +  tableName + " WHERE " + col_IDName + " IS '" + row_IDValue + "'";
    //QString sql = "SELECT " + colName + " FROM " +  tableName;

//    sql = "SELECT * FROM " + tableName + " WHERE id = " + QString::number(rowID) ;


    qry.prepare( sql );
    if( !qry.exec() )
        return sVal;

/*
    while (qry.next())
    {
        qDebug() << qry.value("sql").toString();
        if (qry.value("type").toString() == "table")
        {
            sVal = qry.value("name").toString();
            //tables.append(sVal);
            break;
        }
    }
*/


    QSqlRecord rec = qry.record();

    int cnt = rec.count();

    for (int i=0; i<cnt; i++)
    {
        //QSqlField field = rec.field(i);
        QString fieldName = rec.fieldName(i);
        //QString fieldType = QVariant::typeToName(field.type());
        //QString sValue = QVariant::typeToName(field.value());
    }

    for(int r=0; qry.next(); r++)
    {
        for(int i=0;i<cnt;i++)
        {
            QVariant qVal = qry.value(i);

            QString sVal = qVal.toString();

            return sVal;
            //rowValues.append(sVal);
            break;
        }
    }


    return sVal;
}


bool cSQL_Utils::createTable(QString tableName, QStringList tableColumnNames, QStringList columnTypes)
{
    bool ret = false;
    QSqlQuery qry;


    QString sql;

    sql = "create table " + tableName + " (id integer primary key, ";

    int cnt1 = tableColumnNames.count();
    int cnt2 = columnTypes.count();

    if(cnt1 != cnt2)
        return false;

    int cnt = cnt1;

    for(int i=0;i<cnt;i++)
    {
        if(i==cnt-1)
        {
            sql += tableColumnNames[i] + " " + columnTypes[i] + ")";
        }
        else
        {
            sql += tableColumnNames[i] + " " + columnTypes[i] + ", ";
        }
    }


    qry.prepare( sql );
    if( qry.exec() )
    {
        ret = true;
        db.commit();
    }

    return ret;
}



/*
bool cSQL_Utils::getPerson(int id, PersonData*& person)
    {
    bool ret = false;

    QSqlQuery query(QString("select * from person where id = %1").arg(id));
    if (query.next())
        {
        person->id = query.value(0).toInt();
        person->firstname = query.value(1).toString();
        person->lastname = query.value(2).toString();
        person->age = query.value(3).toInt();
        ret = true;
        }

    return ret;
    }
*/

QStringList cSQL_Utils::getROW_table(QString tableName, int rowID)
{

    QStringList rowValues;
    bool ret = false;
    QSqlQuery qry;


    QString sql;

    sql = "SELECT * FROM " + tableName + " WHERE id = " + QString::number(rowID) ;


    qry.prepare( sql );
    if(!qry.exec() )
        return rowValues;


    QSqlRecord rec = qry.record();

    int cnt = rec.count();

    for (int i=0; i<cnt; i++)
    {
        //QSqlField field = rec.field(i);
        QString fieldName = rec.fieldName(i);
        //QString fieldType = QVariant::typeToName(field.type());
        //QString sValue = QVariant::typeToName(field.value());
    }

    for(int r=0; qry.next(); r++)
    {
        for(int i=0;i<cnt;i++)
        {
            QVariant qVal = qry.value(i);

            QString sVal = qVal.toString();

            rowValues.append(sVal);
        }
    }



    return rowValues;
}



//auto-increments ROW_ID and puts it at end of list in table
//updates our lastRowID value
int cSQL_Utils::insertROW_into_table(QString tableName, QStringList tableColumnNames, QStringList columnValues)
{
    QSqlQuery qry;


     QString sql = "INSERT INTO " + tableName + "( ";

     int cnt  = tableColumnNames.count();
     int cnt2 = columnValues.count();

     if(cnt2 != cnt)
     {
         return -1;
     }


     if(cnt > 0)
     {
         for(int i=0;i<cnt; i++)
         {
             if(i == cnt-1)
             {
                 sql += tableColumnNames[i]  + ") VALUES ( ";

             }
             else
             {
                 sql += tableColumnNames[i] + ", ";
             }
         }


         for(int i=0;i<cnt; i++)
         {
             if(i == cnt-1)
             {
                 sql += "'" + columnValues[i] + "')";

             }
             else
             {
                 sql += "'" + columnValues[i] + "',";
             }
         }

     }
     else
         return false;


     qry.prepare( sql );
     if(!qry.exec() )
         return -1;


    lastRowID = qry.lastInsertId().toInt();


    db.commit();


    return lastRowID;
}

//do a search in a named column for a matching entry (text); returns rowID if found, -1 if not found in column
int cSQL_Utils::getRowID_colQuery_table(QString colName, QString queryName, QString tableName)
{
    int lastRowID=-1;
    QSqlQuery qry;

    QString sql = "SELECT * FROM " +  tableName + " WHERE " + colName + " IS '" + queryName + "'";
    //QString sql = "SELECT " + colName + " FROM " +  tableName;

    qry.prepare( sql );
    if( !qry.exec() )
        return lastRowID;

    qry.last();

    //qry.next();

    int fieldNo = qry.record().indexOf("id");

    QString sLastRowID = qry.value(fieldNo).toString();

    int rowID = sLastRowID.toInt();

    if(rowID > 0)
    {
        lastRowID = rowID;
    }
    else
    {
        rowID = -1;
    }


    return rowID;
}

int cSQL_Utils::getLast_rowID_in_table(QString tableName)
{
    int lastRowID=-1;
    QSqlQuery qry;

    QString sql = "SELECT id FROM " +  tableName;

    qry.prepare( sql );
    if( !qry.exec() )
        return lastRowID;

    qry.last();

    int fieldNo = qry.record().indexOf("id");

    QString sLastRowID = qry.value(fieldNo).toString();

    int rowID = sLastRowID.toInt();

    if(rowID > 0)
    {
        lastRowID = rowID;
    }
    else
    {
        rowID = -1;
    }


    return rowID;

}


bool cSQL_Utils::updateROW_table(QString tableName, int rowID, QStringList tableColumnNames, QStringList columnValues)
{
    bool ret = false;
    QSqlQuery qry;


      QString sql = "UPDATE " + tableName + " SET " ;

      int cnt = tableColumnNames.count();

      if(cnt > 0)
      {
          for(int i=0;i<cnt; i++)
          {
              if(i == cnt-1)
              {
                  sql +=  tableColumnNames[i] + "=" + "'" + columnValues[i] + "' ";

              }
              else
              {
                  sql +=  tableColumnNames[i] + "=" + "'" + columnValues[i] + "', ";
              }
          }

          sql += " WHERE id = " + QString::number(rowID);
      }
      else
          return false;


      qry.prepare( sql );
      if( qry.exec() )
          ret = true;

      db.commit();


    return ret;
}


//note: this deletes the row, but doesn't move any id's so you're left with a hole
bool cSQL_Utils::deleteROW_in_table(QString tableName, int rowID)
{
    bool ret = false;
    QSqlQuery qry;

    QString sql = "DELETE FROM " + tableName + " WHERE id = " + QString::number(rowID);

    qry.prepare( sql );
    if( qry.exec() )
        ret = true;

    db.commit();


    return ret;
}

QString cSQL_Utils::selectALL_in_table(QString tableName, QString sql_search_query)
{
    QString sResults = "";
    QStringList fieldNames;
    QStringList fieldValues;
    QSqlQuery qry;

    QString sql = "SELECT * FROM " + tableName ;



    qry.prepare( sql );
    if( !qry.exec() )
        return sResults;


    QSqlRecord rec = qry.record();

    int cols = rec.count();

    for( int c=0; c<cols; c++ )
    {
       //qDebug() << QString( "Column %1: %2" ).arg( c ).arg( rec.fieldName(c) );

        fieldNames.append(rec.fieldName(c));
    }


    for( int r=0; qry.next(); r++ )
    {
        for( int c=0; c<cols; c++ )
        {
            //qDebug() << QString( "Row %1, %2: %3" ).arg( r ).arg( rec.fieldName(c) ).arg( qry.value(c).toString() );

            fieldValues.append(qry.value(c).toString());
        }
    }

    return sResults;
}


bool check_sql_types(QStringList sql_typeList)
{
    bool ok = false;

    int cnt = sql_typeList.count();

    if(cnt < 1)
    {
        return false;
    }

    for(int i=0;i<cnt;i++)
    {
        QString sqlType = sql_typeList[i];

        sqlType.toUpper();


        if( (sqlType == "TEXT")||(sqlType == "INTEGER")||(sqlType == "FLOAT") )
        {
            ok = true;
        }
        else
        {
            ok = false;
            break;
        }
    }

    return ok;
}


