#ifndef CSQL_UTILS_H
#define CSQL_UTILS_H

#include <QStringList>
#include <QString>

#include <QtSql/QSqlDatabase>
#include <QtSql>
#include <QtSql/QSqlField>


class cSQL_Utils
{
public:
    cSQL_Utils();
    ~cSQL_Utils();

private:

    QSqlDatabase db;

    QStringList dbPathList;
    QStringList dbNamesList;

public:

    bool dbIsOpen = false;

    void setDB_path(QString path);

    bool create_sqlite_dataBase();
    bool create_sqlite_dataBase(QString db_Path);
    bool create_sqlite_dataBase(QString db_Name, QString db_path);
    bool open_sqlite_dataBase();
    bool open_sqlite_dataBase(QString db_path);
    bool attach_sqlite_dataBase(QString db_Name, QString db_path);

    QSqlError lastError();
    bool deleteDB();
    bool closeDB();
    bool dropDB_table(QString tableName);
    bool clearDB_table(QString tableName);

    bool createTable(QString tableName, QStringList tableColumnNames, QStringList columnTypes);
    int insertROW_into_table(QString tableName, QStringList tableColumnNames, QStringList columnValues);
    bool updateROW_table(QString tableName, int rowID, QStringList tableColumnNames, QStringList columnValues);
    QStringList getROW_table(QString tableName, int rowID);
    bool deleteROW_in_table(QString tableName, int rowID);
    int getLast_rowID_in_table(QString tableName);

    QString getValue_colQuery_table(QString col_IDName, QString row_IDValue, QString queryColName, QString tableName);

    //do a search in a named column for a matching entry (text); returns rowID if found, -1 if not found in column
    int getRowID_colQuery_table(QString colName, QString queryName, QString tableName);

    bool check_sql_types(QStringList sql_typeList);

    QStringList getDB_tableNames();
    QStringList getDB_tableColumnNames(QString tableName);
    QStringList getDB_tableTypeNames(QString tableName);

    bool testDB_tableExists(QString tableName);



    QString selectALL_in_table(QString tableName, QString sql_search_query);


    qint32 lastRowID = 0; //note: only valid for last table accessed, so be careful!

    QString dbPath;
    QString dbName;
};

#endif // CSQL_UTILS_H
