#include "cstatistics_utils.h"

cStatistics_utils::cStatistics_utils(QObject *parent) :
    QObject(parent)
{
}

double cStatistics_utils::calc_sum(QList<double> val_list)
{
    double sum = 0.0;

    int cnt = val_list.count();

    for(int i=0;i<cnt;i++)
    {
        sum += val_list[i];
    }

    return sum;
}

double cStatistics_utils::calc_mean(QList<double> val_list)
{
    double mean = 0.0;

    int cnt = val_list.count();

    if(cnt > 0)
    {
        double sum = this->calc_sum(val_list);

        mean = sum / (double)cnt;
    }

    return mean;
}

//use 99% approx for stdev; rather than calc
double cStatistics_utils::calc_stdev(QList<double> val_list)
{

    double min = find_min(val_list);
    double max = find_max(val_list);

    double sigma = ((max - min)/2.0)/3.0;

    return sigma;

}


double cStatistics_utils::find_min(QList<double> val_list)
{
    double min = 9999999.0;
    double val;

    int cnt = val_list.count();

    for(int i=0;i<cnt;i++)
    {
        val = val_list[i];

        if(val < min)
        {
            min = val;
        }
    }

    return min;
}

double cStatistics_utils::find_max(QList<double> val_list)
{
    double max = 0.0;
    double val;

    int cnt = val_list.count();

    for(int i=0;i<cnt;i++)
    {
        val = val_list[i];

        if(val > max)
        {
            max = val;
        }
    }

    return max;

}

double cStatistics_utils::find_median(QList<double> val_list)
{
    QList<double> list;
    double median = -999999.99;

    list = val_list;

    qSort(list.begin(), list.end());

    int cnt = list.count();

    if(cnt > 1)
    {
        int half_way = (int)((double)cnt / 2.0 + 0.5);


        median = val_list[half_way];
    }

    return median;
}

//http://docs.huihoo.com/qt/4.2/qtalgorithms.html#qSort
QList<double> cStatistics_utils::sort_list(QList<double> val_list)
{
    QList<double> list;

    list = val_list;

    qSort(list.begin(), list.end());

    return list;

}



